# Flower Knight Girl API Proxy

## Description

This is a proxy for DMM's version of [Flower Knight Girl](http://www.dmm.co.jp/netgame_s/flower-x/). Currently its main feature is providing a way to use parts of Nutaku's translations (or user-provided translations) in the DMM version.

## Dependencies

* D compiler (tested with ldc) + dub
* [fish](https://fishshell.com/) (for generating translation data)
* [csvquote](https://github.com/dbro/csvquote) (for generating translation data)

## Generating translation data

```bash
$ curl 'http://rn.floweknightgirl.com/api/v1/master/getMaster' (...) > nutakuMaster.zlib
$ printf "\x1f\x8b\x08\x00\x00\x00\x00\x00" | cat - nutakuMaster.zlib | gzip -dc > nutakuMaster.json
$ ./generate-translations.fish
```

(Get the full curl request from your browser's developer tools' network tab when loading **Nutaku's version**.)

## Building

```bash
$ cp source/config.d.example source/config.d
$ # edit source/config.d
$ dub build
```

## Using

```bash
$ echo '127.0.0.1 web.flower-knight-girls.co.jp' | sudo tee -a /etc/hosts
$ ./fkg-api-proxy
```

## Disclaimer

**Update:** The FKG devs have effectively said using a proxy like this for translations won't get you banned, but is unsupported. ([source](https://archive.fo/xldq7#post1213188))

This is most likely against DMM's or FKG's ToS. Use at your own risk. That said, it should be unlikely that you'd get banned for using this, since it shouldn't be detectable from their side.

## License

This project is released under the [University of Illinois/NCSA Open Source License](LICENSE).
